import { world, system } from "@minecraft/server";

system.runInterval(() => { // 毎tick実行される
    for (const player of world.getAllPlayers()) {
        const Dbjump = player.getComponent("minecraft:equippable").getEquipment("Offhand"); // 足に装備してるアイテムを取得
        if (Dbjump?.typeId == "tunekeshi:special_feather" && !player.isSneaking && player.isJumping && !player.hasTag("jump_cooldown") && player.hasTag("onground")) {
          
            const { x, y, z } = player.getViewDirection(); // playerの向いている方向
            player.applyKnockback(x, z, 2, y * 1); // ノックバックを発生させる
            player.playSound("jump.snow",{volume: 0.1, pitch: 0.5}); // サウンドを再生
            player.addTag("jump_cooldown"); // jump_cooldownタグを追加
            system.runTimeout(() => {
                player.removeTag("jump_cooldown"); // 10tick後にjump_cooldownタグを削除
            }, 10);
        
system.runTimeout(() => {
                player.removeTag("onground"); 
            }, 20);
        }
        // player.isOnGroundを上のif文にいれるとplayer.isJumpingと被ってしまうので後に持ってくることで実質1tick前地面に接していたかを検知できる
        if (player.isOnGround) { // プレイヤーが地面に接しているとき
            player.addTag("onground");
        }
        }
    }
);